﻿using BizTracker.Library;
using BizTracker.Library.Helpers;
using BizTracker2015.WebApp.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using BizTracker.Library.Models;

namespace BizTracker2015.WebApp.Controllers
{
  public class HomeController : Controller
  {

    private string TRACKING_SERVERNAME = GeneralHelper.GetTrackingServer();
    private string MANAGEMENT_SERVERNAME = GeneralHelper.GetMgmtServer();
    private string TRACKING_DBNAME = GeneralHelper.GetTrackingDb();
    private string MANAGEMENT_DBNAME = GeneralHelper.GetMgmtDb();

    private string currentServer()
    {
      if (System.Web.HttpContext.Current == null)
      {
        return TRACKING_SERVERNAME;
      }
      else
      {
        if (System.Web.HttpContext.Current.Session["server"] == null)
        {
          return TRACKING_SERVERNAME;
        }
        else
        {
          string s = System.Web.HttpContext.Current.Session["server"].ToString();
          if (String.IsNullOrEmpty(s))
            return TRACKING_SERVERNAME;
          else
            return s;
        }
      }
    }

    public BizTrackerObject GetBTObject
    {

      get
      {
        //In unitTest (needs mockup HttpContext, but not important right now)
        //I have tested manually in Real web context in debug mode, and the else
        //Is indeed hit on the second request.
        if (System.Web.HttpContext.Current == null)
          return new BizTrackerObject(currentServer(), currentServer(), TRACKING_DBNAME, MANAGEMENT_DBNAME);

        if (System.Web.HttpContext.Current.Session["bto"] == null)
        {
          BizTrackerObject bto = new BizTrackerObject(currentServer(), currentServer(), TRACKING_DBNAME, MANAGEMENT_DBNAME);
          System.Web.HttpContext.Current.Session["bto"] = bto;
          return bto;
        }
        else
        {
          return (BizTrackerObject)System.Web.HttpContext.Current.Session["bto"];
        }
      }

    }
    public ActionResult Index()
    {
      return View();
    }

    public ActionResult PortAlert()
    {
      var model = GetBTObject.GetPortAlerts();
      return View(model);
    }


    public ActionResult Alert()
    {
      var model = GetBTObject.GetAlerts();
      List<PortData> portModel = GetBTObject.GetPortAlerts();
      ViewData["portModel"] = portModel;
      return View(model);
    }



    public ActionResult MessageData()
    {
      var model = GetBTObject.GetMessageTypeData();
      return View(model);

    }

    public ActionResult PortData()
    {
      var model = GetBTObject.GetPortData();
      return View(model);
    }

    public ActionResult Properties()
    {
      var model = CustomPropertyFactory.GetCustomProperties(GetBTObject).ToList(); //I use IEnumerable here. Better? It lets me use "yield return"
      return View(model);
    }

    [HttpPost]
    public ActionResult Properties(List<CustomProperty> model)
    {
      System.Web.HttpContext.Current.Session["CustomProperties"] = CustomPropertyFactory.GetCustomPropertiesParamString(model);
      return RedirectToAction("Index", "Home");
    }

    public ActionResult About()
    {
      ViewBag.Message = "Your application description page.";

      return View();
    }

    public ActionResult Contact()
    {
      ViewBag.Message = "Your contact page.";

      return View();
    }
  }
}