﻿using BizTracker2015.WebApp.Data;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Xml.Linq;

namespace BizTracker2015.WebApp.Helpers
{

  public class DataStorageHelper
  {
    private static BTConfigEntities context = new BTConfigEntities();

    public static List<Configuration> GetValues()
    {
      var output = context.Configurations.ToList();
      return output;
    }

    public static int GetMaxBodyLength2()
    {
      int output = GetValue<int>("MaxBodyLength");
      return output;
    }

    public static void SetValue(string key, string value)
    {
      var existingPair = context.Configurations.Where(c => c.Key.ToLower() == key.ToLower()).FirstOrDefault<Configuration>();
      if (existingPair == null)
      {
        //New
        Configuration c = new Configuration() { Key = key, Value = value };
        context.Configurations.Add(c);
      }
      else
      {
        //Existing
        existingPair.Value = value;
        context.Entry(existingPair).State = System.Data.Entity.EntityState.Modified;

      }
      context.SaveChanges();
    }


    public static string GetValue(string key)
    {
      var output = context.Configurations.Where(c => (c.Key.ToLower() == key.ToLower())).FirstOrDefault<Configuration>();
      return output.Value ?? "";
    }

    public static T GetValue<T>(string keyName)
    {
      string sOutput = GetValue(keyName);
      if (sOutput == null)
        return default(T);
      return (T)System.Convert.ChangeType(sOutput, Type.GetTypeCode(typeof(T)));

    }




  }
}