﻿using BizTracker.Library;
using BizTracker.Library.Helpers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using workingIT.Library;

namespace BizTracker2015.WebApp.Models
{
  public class CustomProperty
  {
    public string Name { get; set; }
    public bool Selected { get; set; }
  }

  public class CustomPropertyFactory
  {
    public static IEnumerable<CustomProperty> GetCustomProperties(BizTrackerObject o)
    {
      var selected = GeneralHelper.GetCustomProperties();
      var allProperties = o.GetAvailableTrackedFields();
      //List<CustomProperty> output = new List<CustomProperty>();
      foreach (var prop in allProperties)
      {
        CustomProperty cp = new CustomProperty() { Name = prop, Selected = selected.Contains(prop) };
        //output.Add(cp);
        yield return cp;
      }
      //return output;
    }
    public static string GetCustomPropertiesParamString(List<CustomProperty> c)
    {
      string output = string.Join(",", c.Where(cc => cc.Selected).Select(s => s.Name).ToList());
      return output;
    }

  }

}