﻿var app = angular.module('BTTRApp', ['ui.bootstrap', 'ui.bootstrap.datetimepicker', 'ngRoute', 'ngCookies']);

//app.config(["$provide", function ($provide) {
//          var rootUrl = $("#linkRoot").attr("href");

//          $provide.constant('rootUrl', rootUrl);
//        }])


app.controller('LayoutCtrl', function ($scope, $http, $interval,$location) {
  $scope.clara = "cute";
  $scope.alertsPresent = false;
  $scope.numberOfAlerts = 0;
  $scope.numberOfPortAlerts = 0;
  $scope.numberOfTotalAlerts = 0;
  $scope.doUpdateAlerts = true;
  $scope.editionText = "";
  $scope.serverName = "";
  $scope.selectedServerName = "";
  $scope.servers = [];
  
  $scope.getCorrectApplicationPath = function () {
    var splitArray = $location.absUrl().split('/');
    console.log("Split..");
    console.dir(splitArray);
    return "http://" + splitArray[2] + "/" + splitArray[3] + "/";
  };

  $scope.path = $scope.getCorrectApplicationPath();

  $scope.resetAlerts = function()
  {
    $scope.numberOfAlerts = 0;
    $scope.numberOfPortAlerts = 0;
    $scope.numberOfTotalAlerts = 0;
  }

  $scope.cmdUpdateAlerts = function () {
    $scope.updateAlerts();
  };

  $scope.updateServer = function () {
    $http({
      method: "POST", url: $scope.path + "Track/SetServerName",
      data: { serverName: $scope.selectedServerName }
    })
 .success(function (data) {
   $scope.updateServerName();
 })
 .error(function (data) { });

  };

  $scope.updateServerName = function () {
    var firstPath = $location.absUrl();
    $scope.resetAlerts();

    $http({ method: "GET", url: $scope.path + "Track/GetCurrentServerName" })
    .success(function (data) {
      $scope.serverName = data;
    })
    .error(function (data) { });
  };

  $scope.updateServers = function () {
    var firstPath = $location.absUrl();

    $http({ method: "GET", url: $scope.path + "Track/GetServerNames" })
    .success(function (data) {
      $scope.servers = data;
      $scope.selectedServerName = $scope.servers[0];
      console.log("Servers:");
      console.log($scope.servers.length);

      console.log(data);

    })
    .error(function (data) { });
  };


  $scope.updateEditionText = function () {
    if ($scope.editionText.length > 0)
      return;
    var firstPath = $location.absUrl();

    $http({ method: "GET", url: $scope.path + "Track/GetEditionText" })
    .success(function (data) {
      $scope.editionText = data;
    })
    .error(function (data) { });
  };
    
  $scope.updateAlerts = function() 
  {
    console.log($scope.doUpdateAlerts);
    if (!$scope.doUpdateAlerts) {
      console.log("cancelled...no Auto Alerts");
      return;
    }

    var host = $location.host() + ":" + $location.port();
    var firstPath = $location.absUrl();
    console.dir($location);
    console.log("alerts!!!...");
    //return;
    //console.log("host: " + $location.host() + ":" + $location.port());
    $http({ method: "GET", url: $scope.path + "Track/GetAlerts", params: { expiredOnly: true } })
      .success(function (data) {
        console.log("Got alerts back");
        console.dir(data);
        $scope.numberOfAlerts = data.length;
        $scope.numberOfTotalAlerts = $scope.numberOfPortAlerts + $scope.numberOfAlerts;
      })
      .error(function (data) { });

    //Ports
    $http({ method: "GET", url: $scope.path + "Track/GetPortAlerts", params: { expiredOnly: true } })
   .success(function (data) {
     console.log("Got portalerts back");
     console.dir(data);
     $scope.numberOfPortAlerts = data.length;
     $scope.numberOfTotalAlerts = $scope.numberOfPortAlerts + $scope.numberOfAlerts;

   })
   .error(function (data) { });

  }

  $scope.updateEditionText();
  $scope.updateServerName();
  $scope.updateServers();
  $interval(function () {
    //var d = new Date();
    //$scope.clara = d.getTime();
    console.dir($location);

    $scope.updateAlerts();

  }, 300000);

  $scope.updateAlerts();
});